package com.imin.nfcdemo;

import androidx.appcompat.app.AppCompatActivity;

import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.nfc.NfcAdapter;
import android.os.Bundle;
import android.util.Log;
import android.widget.TextView;

import java.io.UnsupportedEncodingException;

public class MainActivity extends AppCompatActivity {

    private TextView number;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        number = findViewById(R.id.number_credits);
        if (isNFCSupported(this)){
            NfcUtils nfcUtils = new NfcUtils(this);
        }
    }
    public static boolean isNFCSupported(Context context){
        NfcAdapter mNfcAdapter = NfcAdapter.getDefaultAdapter(context);
        PackageManager mPackageManager = context.getPackageManager();
        if (!mPackageManager.hasSystemFeature(PackageManager.FEATURE_NFC)
                || !mPackageManager.hasSystemFeature(
                PackageManager.FEATURE_NFC_HOST_CARD_EMULATION)) {
            return false;
        }
        if (mNfcAdapter == null){
            return false;
        }
        if (!mNfcAdapter.isEnabled()){
            return false;
        }
        return true;
    }
    @Override
    protected void onResume() {
        super.onResume();
        if (NfcUtils.mNfcAdapter != null){
            //开启前台调度系统
            NfcUtils.mNfcAdapter.enableForegroundDispatch(this, NfcUtils.mPendingIntent, NfcUtils.mIntentFilter, NfcUtils.mTechList);
        }
    }

    @Override
    protected void onPause() {
        super.onPause();
        if (NfcUtils.mNfcAdapter != null){
            //关闭前台调度系统
            NfcUtils.mNfcAdapter.disableForegroundDispatch(this);
        }
    }

    @Override
    protected void onNewIntent(Intent intent) {
        super.onNewIntent(intent);
        if (NfcUtils.mNfcAdapter != null){
            //当该Activity接收到NFC标签时，运行该方法
            //调用工具方法，读取NFC数据
            try {
                String str = NfcUtils.readNFCFromTag(intent);
                Log.d("imin_hadrd","onNewIntent ==str == >"+str+"  ,NFC ID==》  "+NfcUtils.readNFCId(intent));

                String nfcId = NfcUtils.readNFCId(intent);
                if (nfcId.length() >0){

                    format(number,nfcId);
                }else {

                    number.setText("0");
                }
            } catch (UnsupportedEncodingException e) {
                e.printStackTrace();
            }
        }
    }

    private static String WHITE_SPACE = " ";
    public static void format(TextView textView, String s) {
        if (s.length()==0 || s.isEmpty() || s.equals("null")){
            return;
        }
        String str = s.trim().replaceAll(WHITE_SPACE, "");
        int len = str.length();
        int courPos;

        StringBuilder builder = new StringBuilder();
        for (int i = 0; i < len; i++) {
            builder.append(str.charAt(i));
            if (i == 3 || i == 7 || i == 11 || i == 15) {
                if (i != len - 1)
                    builder.append(WHITE_SPACE);
            }
        }
        courPos = builder.length();
        textView.setText(builder.toString());

    }

    @Override
    protected void onDestroy() {
        super.onDestroy();


    }

}